// Code generated by protoc-gen-connect-go. DO NOT EDIT.
//
// Source: gateway/events/v1/events.proto

package eventsv1connect

import (
	connect "connectrpc.com/connect"
	context "context"
	errors "errors"
	v1 "gitlab.com/binarygame/microservices/gateway/pkg/gen/gateway/events/v1"
	http "net/http"
	strings "strings"
)

// This is a compile-time assertion to ensure that this generated file and the connect package are
// compatible. If you get a compiler error that this constant is not defined, this code was
// generated with a version of connect newer than the one compiled into your binary. You can fix the
// problem by either regenerating this code with an older version of connect or updating the connect
// version compiled into your binary.
const _ = connect.IsAtLeastVersion1_13_0

const (
	// EventsServiceName is the fully-qualified name of the EventsService service.
	EventsServiceName = "gateway.events.v1.EventsService"
)

// These constants are the fully-qualified names of the RPCs defined in this package. They're
// exposed at runtime as Spec.Procedure and as the final two segments of the HTTP route.
//
// Note that these are different from the fully-qualified method names used by
// google.golang.org/protobuf/reflect/protoreflect. To convert from these constants to
// reflection-formatted method names, remove the leading slash and convert the remaining slash to a
// period.
const (
	// EventsServiceSubscribeEventsProcedure is the fully-qualified name of the EventsService's
	// SubscribeEvents RPC.
	EventsServiceSubscribeEventsProcedure = "/gateway.events.v1.EventsService/SubscribeEvents"
)

// These variables are the protoreflect.Descriptor objects for the RPCs defined in this package.
var (
	eventsServiceServiceDescriptor               = v1.File_gateway_events_v1_events_proto.Services().ByName("EventsService")
	eventsServiceSubscribeEventsMethodDescriptor = eventsServiceServiceDescriptor.Methods().ByName("SubscribeEvents")
)

// EventsServiceClient is a client for the gateway.events.v1.EventsService service.
type EventsServiceClient interface {
	// RPC to start receiving a stream of events pertaining to a room
	SubscribeEvents(context.Context, *connect.Request[v1.SubscribeEventsRequest]) (*connect.ServerStreamForClient[v1.SubscribeEventsResponse], error)
}

// NewEventsServiceClient constructs a client for the gateway.events.v1.EventsService service. By
// default, it uses the Connect protocol with the binary Protobuf Codec, asks for gzipped responses,
// and sends uncompressed requests. To use the gRPC or gRPC-Web protocols, supply the
// connect.WithGRPC() or connect.WithGRPCWeb() options.
//
// The URL supplied here should be the base URL for the Connect or gRPC server (for example,
// http://api.acme.com or https://acme.com/grpc).
func NewEventsServiceClient(httpClient connect.HTTPClient, baseURL string, opts ...connect.ClientOption) EventsServiceClient {
	baseURL = strings.TrimRight(baseURL, "/")
	return &eventsServiceClient{
		subscribeEvents: connect.NewClient[v1.SubscribeEventsRequest, v1.SubscribeEventsResponse](
			httpClient,
			baseURL+EventsServiceSubscribeEventsProcedure,
			connect.WithSchema(eventsServiceSubscribeEventsMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
	}
}

// eventsServiceClient implements EventsServiceClient.
type eventsServiceClient struct {
	subscribeEvents *connect.Client[v1.SubscribeEventsRequest, v1.SubscribeEventsResponse]
}

// SubscribeEvents calls gateway.events.v1.EventsService.SubscribeEvents.
func (c *eventsServiceClient) SubscribeEvents(ctx context.Context, req *connect.Request[v1.SubscribeEventsRequest]) (*connect.ServerStreamForClient[v1.SubscribeEventsResponse], error) {
	return c.subscribeEvents.CallServerStream(ctx, req)
}

// EventsServiceHandler is an implementation of the gateway.events.v1.EventsService service.
type EventsServiceHandler interface {
	// RPC to start receiving a stream of events pertaining to a room
	SubscribeEvents(context.Context, *connect.Request[v1.SubscribeEventsRequest], *connect.ServerStream[v1.SubscribeEventsResponse]) error
}

// NewEventsServiceHandler builds an HTTP handler from the service implementation. It returns the
// path on which to mount the handler and the handler itself.
//
// By default, handlers support the Connect, gRPC, and gRPC-Web protocols with the binary Protobuf
// and JSON codecs. They also support gzip compression.
func NewEventsServiceHandler(svc EventsServiceHandler, opts ...connect.HandlerOption) (string, http.Handler) {
	eventsServiceSubscribeEventsHandler := connect.NewServerStreamHandler(
		EventsServiceSubscribeEventsProcedure,
		svc.SubscribeEvents,
		connect.WithSchema(eventsServiceSubscribeEventsMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	return "/gateway.events.v1.EventsService/", http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		switch r.URL.Path {
		case EventsServiceSubscribeEventsProcedure:
			eventsServiceSubscribeEventsHandler.ServeHTTP(w, r)
		default:
			http.NotFound(w, r)
		}
	})
}

// UnimplementedEventsServiceHandler returns CodeUnimplemented from all methods.
type UnimplementedEventsServiceHandler struct{}

func (UnimplementedEventsServiceHandler) SubscribeEvents(context.Context, *connect.Request[v1.SubscribeEventsRequest], *connect.ServerStream[v1.SubscribeEventsResponse]) error {
	return connect.NewError(connect.CodeUnimplemented, errors.New("gateway.events.v1.EventsService.SubscribeEvents is not implemented"))
}
